/* utblstats.p
 *
 * example test harness for using lib/usertablestats.p
 *
 * mpro /db/db/s2k -p lib/utblstats.p
 *
 */

{lib/userstats.i}

define variable myUserNum   as integer no-undo.
define variable myUserid    as integer no-undo.

define variable dbx         as int64   no-undo.
define variable osRd        as int64   no-undo.

define variable i           as integer no-undo.

define variable showTiming  as logical no-undo.


/* who am i?
 */

find dictdb._myConnect no-lock.				/* _myConnect is a somewhat strange VST			*/
myUserNum = _myConn-UserId.				/* yes, this is confusing - but it is correct		*/
myUserid  = _myConn-UserId + 1.				/* the "id" corresponding to VSTs keyed to user ids	*/

etime( yes ).

run ./lib/usertablestats.p persistent.

if showTiming then
  do:
    message etime "ms to setup PP".
    pause.
  end.

etime( yes ).

find dictdb._userio no-lock where _userio-id = myUserId.
assign
  dbx  = _userio-dbAccess
  osRd = _userio-dbRead
.



/****************************************************************************/
/*                                                                          */
/* code to test goes here:                                                  */
/*                                                                          */
/****************************************************************************/

/* &GLOBAL-DEFINE TBLNAME customer */

&IF DEFINED( TBLNAME ) &THEN

for each {&TBLNAME} no-lock:
  i = i + 1.
end.

&ENDIF

/****************************************************************************/
/*                                                                          */
/* end of code to test                                                      */
/*                                                                          */
/****************************************************************************/



find dictdb._userio no-lock where _userio-id = myUserId.
assign
  dbx  = _userio-dbAccess - dbx
  osRd = _userio-dbRead   - osRd
.

message i "{&TBLNAME} records fetched with" dbx "block accesses and" osRd "disk reads".

if showTiming then
  do:
    message etime "ms to run test code".
    pause.
  end.

etime( yes ).

/* get results
 */

run getUStats ( output table tt_usrTblInfo by-reference, output table tt_usrIdxInfo by-reference, output table tt_usrLOBInfo by-reference ).

if showTiming then
  do:
    message etime "ms to get table & index stats".
  end.

etime( yes ).

for each tt_usrTblInfo where tblName = "{&TBLNAME}":
  display tt_usrTblInfo with 1 down.
end.

for each tt_usrIdxInfo where idxName begins "{&TBLNAME}.":
  display tt_usrIdxInfo.
end.

pause.

quit.
