/* lib/viewer.p
 *
 * generic data viewer setup
 *
 * protop.p runs this to initialize UI
 *
 */

{lib/dynscreen.i}

define input parameter dispOrder as integer   no-undo.
define input parameter scrTitle  as character no-undo.
define input parameter dcName    as character no-undo.
define input parameter ttName    as character no-undo.
define input parameter minRows   as integer   no-undo.
define input parameter maxRows   as integer   no-undo.
define input parameter keyCmd    as character no-undo.

define new global shared variable pt_altWidth     as character no-undo.

define variable f as handle no-undo.

define variable showMe as logical no-undo initial no.

procedure showMe:
/*
 *  showMe = not( f:visible ).
 *  assign
 *    f:visible = showMe
 *    f:hidden  = not( showMe )
 *  .
 */
end.

/* setup
 *
 */

create frame f.
assign
  f:row           = 4				/* 2 lines for the header, plus a blank				*/
  f:column        = 1 
  f:box           = no
  f:top-only      = false
  f:overlay       = true
  f:name          = ttName
  f:private-data  = scrTitle
no-error.

if pt_altWidth = "" then
  f:width-chars   = ( if dcName = "dbId" then 160 else 255 ).
 else
  f:width-chars   = ( if dcName = "dbId" then 80 else 58 ).				/* 58 prevents "flicker" of the "Of Interest" box	*/
											/* but prevents using wider viewers			*/
if session:window-system <> "tty" then
  assign
    f:width-chars = 162
    f:scrollable  = false
  .

run dynViewerInit( f, dcName, ttName, dispOrder, minRows, maxRows, keyCmd ).

/* initialize
 *
 */

publish "protop_register" ( dcName ).

subscribe to "protop_" + dcName anywhere run-procedure "showMe".

return.
