/* util/dohc.p
 *
 * healthcheck hotkey
 *
 * march 20, 2020 */

define new global shared variable pt_shortname as character no-undo.
define new global shared variable pt_tmpdir    as character no-undo.

define variable custId as character no-undo.

run myCustid ( output custId ).
if custId = "" or custId = ? or custId = "local" then
  do:
    message
      skip(1)
      " You must have an Enterprise ProTop Portal customer Id to run a  " skip
      " Health Check.                                                   " skip
      skip(1)
      " If you are not an Enterprise ProTop customer and would like to  " skip
      " become one please contact info@wss.com.                         " skip
      skip(1)
     view-as
       alert-box information
       title " Health Check "
    .
    return.
  end.

if opsys = "unix" then
  os-command value( substitute( "./bin/hc.sh    &1 60 5 7 > &2/hc.&1.err  2>&&1 &&", pt_shortname, pt_tmpdir )).
 else
  os-command value( substitute( ".~\bin~\hc.bat &1 60 5 7 > &2~\hc.&1.err 2>&&1 &&", pt_shortname, pt_tmpdir )).

if session:batch = no then
  do:

    message
      skip(1)
      " If you are a ProTop Enterprise customer the Health Check should " skip
      " be available on your portal in approximately 10 minutes.        " skip
      skip(1)
      " If you are not a ProTop Enterprise customer and would like to   " skip
      " become one please contact info@wss.com.                         " skip
      skip(1)
     view-as
      alert-box information
      title " Health Check "
    .

  end.


return.
